package unibo.cs.labss.editor.il.model;

/**
 * E' l'intefaccia comune a tutte le espressioni del linguaggio. <p/>
 * Le classi che rappresentano una espressione devono
 * implementare i metodi per essere valutate e stampate.<br/>
 * Le classi che rappresentano una espressione costante devono implementare
 * <tt>Literal</tt> che  una interfaccia pi specifica. <p/>
 *
 * Le implementazioni che rappresentano una variabile sono tenute a
 * ridefinire il metodo <tt>public String toString()</tt> ereditato da
 * <tt>Object</tt> in modo da produrre una stringa che rappresenti il
 * valore della variabile.
 *
 * @author Riccardo Solmi
 * @version 1.0
 * @see IILFactory
 */

public interface Expression extends IILEntity {
	public boolean hasPrecedence(Expression op);
}
