package unibo.cs.labss.editor.il.model;

/**
 * @author Riccardo Solmi
 */
public interface IILFactory {
	public IILEntity createProgram(IILEntity rootEntity);

	public Statement createWhile(Expression exp, Statement stm);
	public Statement createIf(Expression exp, Statement stm);
	public Statement createIf(Expression exp, Statement thenStm, Statement elseStm);
	public Statement createAssignment(Expression var, Expression exp);
	public Statement createBlock(Statement[] stm);
	public Statement createPrint(Expression var);
	
	public Literal createLiteral(boolean val);
	public Literal createLiteral(int val);

	public Expression createVariable(String name);
	public Expression createAddition(Expression exp1, Expression exp2);
	public Expression createSubtraction(Expression exp1, Expression exp2);
	public Expression createMultiplication(Expression exp1, Expression exp2);
	public Expression createDivision(Expression exp1, Expression exp2);
	public Expression createAnd(Expression exp1, Expression exp2);
	public Expression createOr(Expression exp1, Expression exp2);
	public Expression createNot(Expression exp);
	public Expression createEquals(Expression exp1, Expression exp2);
	public Expression createLessThan(Expression exp1, Expression exp2);
	public Expression createGreaterThan(Expression exp1, Expression exp2);
	
	public Expression createEmptyExpression();
	public Expression createEmptyBooleanExpression();
	public Expression createEmptyIntegerExpression();
	public Statement createEmptyStatement();
}
