package unibo.cs.labss.editor.il.model;

import unibo.cs.labss.editor.il.model.impl.*;

/**
 * @author Riccardo Solmi
 */
public interface IILVisitor {
	public void visitProgram(Program p);

	public void visitBlock(BlockStatement stm);
	public void visitIf(IfStatement stm);
	public void visitIfElse(IfElseStatement stm);
	public void visitAssignment(AssignmentStatement stm);
	public void visitWhile(WhileStatement stm);
	public void visitPrint(PrintStatement stm);

	public void visitBooleanLiteral(Literal exp);
	public void visitIntegerLiteral(Literal exp);
	public void visitVoidLiteral(Literal exp);
	public void visitVariable(Variable exp);

	public void visitEmpty(EmptyStatement exp);
	public void visitEmpty(EmptyExpression exp);
	public void visitEmptyBoolean(EmptyBooleanExpression exp);
	public void visitEmptyInteger(EmptyIntegerExpression exp);

	public void visitAddition(AdditionExpression exp);
	public void visitSubtraction(SubtractionExpression exp);
	public void visitMultiplication(MultiplicationExpression exp);
	public void visitDivision(DivisionExpression exp);

	public void visitEquals(EqualsExpression exp);
	public void visitGreaterThan(GreaterThanExpression exp);
	public void visitLessThan(LessThanExpression exp);

	public void visitAnd(AndExpression exp);
	public void visitOr(OrExpression exp);
	public void visitNot(NotExpression exp);
}
