package unibo.cs.labss.editor.il.model.impl;

import unibo.cs.labss.editor.il.model.Expression;
import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.model.IModel;

/**
 * @author Riccardo Solmi
 */
public abstract class AbstractBinaryExpression extends AbstractExpression {
	protected Expression exp1;
	protected Expression exp2;
	private final String opStr;

	public AbstractBinaryExpression(OperatorGroup opGroup, Expression exp1, Expression exp2, String opStr) {
		super(opGroup);
		this.exp1 = exp1;
		this.exp2 = exp2;
		this.opStr = opStr;
	}

    public Object clone() {
    	AbstractBinaryExpression abe = (AbstractBinaryExpression)super.clone();
		abe.exp1 = (Expression)exp1.clone();
		abe.exp2 = (Expression)exp2.clone();
		return abe;
	}

    protected void setChildrenModel(IModel model) {
    	exp1.setModel(model);
    	exp2.setModel(model);
    }

	public Expression getExp1() {
		return exp1;
	}

	public Expression getExp2() {
		return exp2;
	}

	public void setExp1(Expression exp1) {
		notifyChanged(this.exp1, this.exp1 = exp1);
	}

	public void setExp2(Expression exp2) {
		notifyChanged(this.exp2, this.exp2 = exp2);
	}

	public void replaceChild(IEntity oldChild, IEntity newChild) {
		if (getExp1() == oldChild)
			setExp1((Expression)newChild);
		else if (getExp2() == oldChild)
			setExp2((Expression)newChild);
	}
}
