package unibo.cs.labss.editor.il.model.impl;

import unibo.cs.labss.editor.model.AbstractEntity;
import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.il.model.*;


abstract class AbstractExpression extends AbstractEntity implements Expression {
	private final OperatorGroup precedence;

	public AbstractExpression(OperatorGroup precedence) {
		this.precedence = precedence;
	}

	public boolean hasPrecedence(Expression exp) {
		if (exp instanceof AbstractExpression)
			return precedence.hasPrecedence(((AbstractExpression)exp).precedence);
		else
			return false;
	}
	
	public void replaceChild(IEntity oldChild, IEntity newChild) {
		throw new IllegalArgumentException();
	}
}
