package unibo.cs.labss.editor.il.model.impl;

import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.model.AbstractEntity;
import unibo.cs.labss.editor.model.IModel;
import unibo.cs.labss.editor.il.model.Expression;
import unibo.cs.labss.editor.il.model.IILVisitor;
import unibo.cs.labss.editor.il.model.Statement;

/**
 * @author Riccardo Solmi
 */
public class AssignmentStatement extends AbstractEntity implements Statement {
	private Variable id;
	private Expression exp;

	public AssignmentStatement() {
		this(null, null);
	}
	public AssignmentStatement(Expression id, Expression exp) {
		this.id = (Variable) id;
		this.exp = exp;
	}

    public Object clone() {
    	AssignmentStatement as = (AssignmentStatement)super.clone();
		as.id = (Variable)id.clone();
		as.exp = (Expression)exp.clone();
		return as;
	}

    protected void setChildrenModel(IModel model) {
    	id.setModel(model);
    	exp.setModel(model);
    }

	public Expression getExp() {
		return exp;
	}

	public Variable getId() {
		return id;
	}

	public void setExp(Expression exp) {
		notifyChanged(this.exp, this.exp = exp);
	}

	public void setId(Variable id) {
		notifyChanged(this.id, this.id = id);
	}
	
	public void replaceChild(IEntity oldChild, IEntity newChild) {
		if (getExp() == oldChild)
			setExp((Expression)newChild);
		else if (getId() == oldChild && newChild instanceof Variable)
			setId((Variable)newChild);
	}

	public void accept(IILVisitor visitor) {
		visitor.visitAssignment(this);
	}
}
