package unibo.cs.labss.editor.il.model.impl;
import java.io.PrintStream;

import unibo.cs.labss.editor.il.model.BooleanExpression;
import unibo.cs.labss.editor.il.model.IILVisitor;

/**
 * @author Riccardo Solmi
 */
public class BooleanLiteral extends AbstractLiteral implements BooleanExpression {
	public static final BooleanLiteral TRUE = new BooleanLiteral(true);
	public static final BooleanLiteral FALSE = new BooleanLiteral(false);
	public static final BooleanLiteral create(boolean value) {
		return value ? TRUE : FALSE;
	}

	private boolean val;
	
	public BooleanLiteral() {
		this(true);
	}
	private BooleanLiteral(boolean val) {
		super(OperatorGroup.LITERAL);
		this.val = val;
	}

	// TODO clone return this

	public void prettyPrint(PrintStream out) {
		out.print(val);
	}
	public boolean booleanValue() {
		return val;
	}
	
	public String toString() {
		return String.valueOf(val);
	}
	
	public boolean isVal() {
		return val;
	}

	public void setVal(boolean val) {
		notifyChanged("value", this.val, this.val = val);
	}

	public void accept(IILVisitor visitor) {
		visitor.visitBooleanLiteral(this);
	}
}