package unibo.cs.labss.editor.il.model.impl;

import unibo.cs.labss.editor.AbstractPrototypeManager;
import unibo.cs.labss.editor.IPrototypeManager;
import unibo.cs.labss.editor.il.model.IILEntity;
import unibo.cs.labss.editor.il.model.IILFactory;
import unibo.cs.labss.editor.il.model.Statement;
import unibo.cs.labss.editor.model.IEntity;

/**
 * @author Riccardo Solmi
 */
public class ILPrototypeManager extends AbstractPrototypeManager {
	private static IPrototypeManager instance;
	public static final IPrototypeManager instance() {
		if (instance == null)
			instance = new ILPrototypeManager();
		return instance;
	}

	private ILPrototypeManager() {
		IILFactory lf = ILLanguageFactory.instance;

		put("WhileStatement", lf.createWhile(lf.createEmptyBooleanExpression(), lf.createEmptyStatement()));
		put("IfStatement", lf.createIf(lf.createEmptyBooleanExpression(), lf.createEmptyStatement()));
		put("IfElseStatement", lf.createIf(lf.createEmptyBooleanExpression(), lf.createEmptyStatement(), lf.createEmptyStatement()));
		put("AssignmentStatement", lf.createAssignment(lf.createVariable("fresh"), lf.createEmptyExpression()));
		put("BlockStatement", lf.createBlock(new Statement[] {lf.createEmptyStatement()}));
		put("PrintStatement", lf.createPrint(lf.createEmptyExpression()));

		put("BooleanLiteral", lf.createLiteral(true));
		put("IntegerLiteral", lf.createLiteral(0));

		put("Variable", lf.createVariable("fresh"));

		put("AdditionExpression", lf.createAddition(lf.createEmptyIntegerExpression(), lf.createEmptyIntegerExpression()));
		put("SubtractionExpression", lf.createSubtraction(lf.createEmptyIntegerExpression(), lf.createEmptyIntegerExpression()));
		put("MultiplicationExpression", lf.createMultiplication(lf.createEmptyIntegerExpression(), lf.createEmptyIntegerExpression()));
		put("DivisionExpression", lf.createDivision(lf.createEmptyIntegerExpression(), lf.createEmptyIntegerExpression()));
		
		put("AndExpression", lf.createAnd(lf.createEmptyBooleanExpression(), lf.createEmptyBooleanExpression()));
		put("OrExpression", lf.createOr(lf.createEmptyBooleanExpression(), lf.createEmptyBooleanExpression()));
		put("NotExpression", lf.createNot(lf.createEmptyBooleanExpression()));

		put("EqualsExpression", lf.createEquals(lf.createEmptyIntegerExpression(), lf.createEmptyIntegerExpression()));
		put("LessThanExpression", lf.createLessThan(lf.createEmptyIntegerExpression(), lf.createEmptyIntegerExpression()));
		put("GreaterThanExpression", lf.createGreaterThan(lf.createEmptyIntegerExpression(), lf.createEmptyIntegerExpression()));

		put("EmptyExpression", lf.createEmptyExpression());
		put("EmptyBooleanExpression", lf.createEmptyBooleanExpression());
		put("EmptyIntegerExpression", lf.createEmptyIntegerExpression());
		put("EmptyStatement", lf.createEmptyStatement());
	}

	protected IEntity clone(IEntity prototype) {
		return (IEntity)((IILEntity)prototype).clone();
	}
}
