package unibo.cs.labss.editor.il.model.impl;

import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.model.AbstractEntity;
import unibo.cs.labss.editor.model.IModel;
import unibo.cs.labss.editor.il.model.Expression;
import unibo.cs.labss.editor.il.model.IILVisitor;
import unibo.cs.labss.editor.il.model.Statement;

/**
 * @author Riccardo Solmi
 */
public class IfElseStatement extends AbstractEntity implements Statement {
	private Expression exp;
	private Statement thenStm;
	private Statement elseStm;

	public IfElseStatement() {
		this(null, null, null);
	}
	public IfElseStatement(Expression exp, Statement thenStm, Statement elseStm) {
		this.exp = exp;
		this.thenStm = thenStm;
		this.elseStm = elseStm;
	}

    public Object clone() {
    	IfElseStatement is = (IfElseStatement)super.clone();
		is.exp = (Expression)exp.clone();
		is.thenStm = (Statement)thenStm.clone();
		is.elseStm = (Statement)elseStm.clone();
		return is;
	}

    protected void setChildrenModel(IModel model) {
    	exp.setModel(model);
    	thenStm.setModel(model);
    	elseStm.setModel(model);
    }

	public Statement getElseStm() {
		return elseStm;
	}

	public Expression getExp() {
		return exp;
	}

	public Statement getThenStm() {
		return thenStm;
	}

	public void setElseStm(Statement elseStm) {
		notifyChanged(this.elseStm, this.elseStm = elseStm);
	}
	public void setExp(Expression exp) {
		notifyChanged(this.exp, this.exp = exp);
	}
	public void setThenStm(Statement thenStm) {
		notifyChanged(this.thenStm, this.thenStm = thenStm);
	}

	public void replaceChild(IEntity oldChild, IEntity newChild) {
		if (getExp() == oldChild)
			setExp((Expression)newChild);
		else if (getThenStm() == oldChild)
			setThenStm((Statement)newChild);
		else if (getElseStm() == oldChild)
			setElseStm((Statement)newChild);
	}

	public void accept(IILVisitor visitor) {
		visitor.visitIfElse(this);
	}
}