package unibo.cs.labss.editor.il.model.impl;

import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.model.AbstractEntity;
import unibo.cs.labss.editor.model.IModel;
import unibo.cs.labss.editor.il.model.Expression;
import unibo.cs.labss.editor.il.model.IILVisitor;
import unibo.cs.labss.editor.il.model.Statement;

/**
 * @author Riccardo Solmi
 */
public class IfStatement extends AbstractEntity implements Statement {
	private Expression exp;
	private Statement thenStm;

	public IfStatement() {
		this(null, null);
	}
	public IfStatement(Expression exp, Statement thenStm) {
		this.exp = exp;
		this.thenStm = thenStm;
	}

    public Object clone() {
    	IfStatement is = (IfStatement)super.clone();
		is.exp = (Expression)exp.clone();
		is.thenStm = (Statement)thenStm.clone();
		return is;
	}

    protected void setChildrenModel(IModel model) {
    	exp.setModel(model);
    	thenStm.setModel(model);
    }

	public Expression getExp() {
		return exp;
	}

	public Statement getThenStm() {
		return thenStm;
	}

	public void setExp(Expression exp) {
		notifyChanged(this.exp, this.exp = exp);
	}
	public void setThenStm(Statement thenStm) {
		notifyChanged(this.thenStm, this.thenStm = thenStm);
	}

	public void replaceChild(IEntity oldChild, IEntity newChild) {
		if (getExp() == oldChild)
			setExp((Expression)newChild);
		else if (getThenStm() == oldChild)
			setThenStm((Statement)newChild);
	}

	public void accept(IILVisitor visitor) {
		visitor.visitIf(this);
	}
}