package unibo.cs.labss.editor.il.model.impl;
import java.io.PrintStream;

import unibo.cs.labss.editor.il.model.IntegerExpression;
import unibo.cs.labss.editor.il.model.IILVisitor;

/**
 * @author Riccardo Solmi
 */
public class IntegerLiteral extends AbstractLiteral implements IntegerExpression {
	public static IntegerLiteral create(int val) {
		return new IntegerLiteral(val);
	}

	private int val;
	
	public IntegerLiteral() {
		this(0);
	}
	public IntegerLiteral(int val) {
		super(OperatorGroup.LITERAL);
		this.val = val;
	}
	
	public void prettyPrint(PrintStream out) {
		out.print(val);
	}
	public int intValue() {
		return val;
	}
	public String toString() {
		return String.valueOf(val);
	}

	public int getVal() {
		return val;
	}

	public void setVal(int val) {
		notifyChanged("value", this.val, this.val = val);
	}

	public void accept(IILVisitor visitor) {
		visitor.visitIntegerLiteral(this);
	}
}