package unibo.cs.labss.editor.il.model.impl;

import unibo.cs.labss.editor.il.model.Expression;
import unibo.cs.labss.editor.il.model.IILVisitor;
import unibo.cs.labss.editor.il.model.LogicalExpression;
import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.model.IModel;

/**
 * @author Riccardo Solmi
 */
public class NotExpression extends AbstractExpression implements LogicalExpression {
	private Expression exp;

	public NotExpression() {
		this(null);
	}
	public NotExpression(Expression exp) {
		super(OperatorGroup.UNARY);
		this.exp = exp;
	}

    public Object clone() {
    	NotExpression ne = (NotExpression)super.clone();
		ne.exp = (Expression)exp.clone();
		return ne;
	}

    protected void setChildrenModel(IModel model) {
    	exp.setModel(model);
    }

	public Expression getExp() {
		return exp;
	}
	public void setExp(Expression exp) {
		notifyChanged(this.exp, this.exp = exp);
	}

	public void replaceChild(IEntity oldChild, IEntity newChild) {
		if (getExp() == oldChild)
			setExp((Expression)newChild);
	}

	public void accept(IILVisitor visitor) {
		visitor.visitNot(this);
	}
}
