package unibo.cs.labss.editor.il.model.impl;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * @author Riccardo Solmi
 */
public class OperatorGroup implements Serializable, Cloneable {
	public static final OperatorGroup LITERAL = new OperatorGroup();
	public static final OperatorGroup POSTFIX = new OperatorGroup(); // [] .
	public static final OperatorGroup UNARY = new OperatorGroup(); // !
	public static final OperatorGroup CREATION_CAST = new OperatorGroup(); // new clone (type)
	public static final OperatorGroup MULTIPLICATIVE = new OperatorGroup(); // * / %
	public static final OperatorGroup ADDITIVE = new OperatorGroup(); // + -
	public static final OperatorGroup RELATIONAL = new OperatorGroup(); // < > <= >= instanceof
	public static final OperatorGroup EQUALITY = new OperatorGroup(); // == !=
	public static final OperatorGroup LOGICAL_AND = new OperatorGroup(); // &&
	public static final OperatorGroup LOGICAL_OR = new OperatorGroup(); // ||
	public static final OperatorGroup CONDITIONAL = new OperatorGroup(); // ?:
	public static final OperatorGroup ASSIGNMENT = new OperatorGroup(); // =

	private static transient ArrayList operators;
	

	private static int _precedence;
	private int precedence;

	private OperatorGroup() {
		if(operators == null)
			operators = new ArrayList();
		precedence = _precedence++;
		operators.add(this);
	}

	public boolean hasPrecedence(OperatorGroup op) {
		return precedence < op.precedence;
	}

	public Object clone() {
		return this;
	}

	protected Object readResolve() {
		return operators.get(precedence);
    }
}
