package unibo.cs.labss.editor.il.model.impl;

import unibo.cs.labss.editor.il.model.Expression;
import unibo.cs.labss.editor.il.model.IILVisitor;
import unibo.cs.labss.editor.il.model.Statement;
import unibo.cs.labss.editor.model.AbstractEntity;
import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.model.IModel;

/**
 * @author Riccardo Solmi
 */
public class PrintStatement extends AbstractEntity implements Statement {
	private Expression exp;
	
	public PrintStatement() {
	}
	public PrintStatement(Expression exp) {
		this.exp = exp;
	}

	public Object clone() {
		PrintStatement stm = (PrintStatement)super.clone();
		stm.exp = (Expression)exp.clone();
		return stm;
	}

    protected void setChildrenModel(IModel model) {
    	exp.setModel(model);
    }

	public Expression getExp() {
		return exp;
	}
	public void setExp(Expression exp) {
		notifyChanged(this.exp, this.exp = exp);
	}

	public void replaceChild(IEntity oldChild, IEntity newChild) {
		if (getExp() == oldChild)
			setExp((Expression)newChild);
	}

	public void accept(IILVisitor visitor) {
		visitor.visitPrint(this);
	}
}
