package unibo.cs.labss.editor.il.model.impl;

import unibo.cs.labss.editor.model.AbstractEntity;
import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.model.IModel;
import unibo.cs.labss.editor.il.model.IILEntity;
import unibo.cs.labss.editor.il.model.IILVisitor;

/**
 * @author Riccardo Solmi
 */
public class Program extends AbstractEntity implements IILEntity {
	private IILEntity rootEntity;

	public Program() {
	}
	public Program(IILEntity rootEntity) {
		this.rootEntity = rootEntity;
	}
	
    public Object clone() {
    	Program p = (Program)super.clone();
		p.rootEntity = (IILEntity)rootEntity.clone();
		return p;
	}

    protected void setChildrenModel(IModel model) {
    	rootEntity.setModel(model);
    }

	public IILEntity getRootEntity() {
		return rootEntity;
	}
    public void setRootEntity(IILEntity rootEntity) {
        notifyChanged(this.rootEntity, this.rootEntity = rootEntity);
    }

	public void accept(IILVisitor visitor) {
		visitor.visitProgram(this);
	}

	public void replaceChild(IEntity oldChild, IEntity newChild) {
		if (getRootEntity() == oldChild)
			setRootEntity((IILEntity)newChild);
	}
}
