package unibo.cs.labss.editor.il.model.impl;

import unibo.cs.labss.editor.il.model.IILVisitor;
import unibo.cs.labss.editor.il.model.Literal;

/**
 * @author Riccardo Solmi
 */
public class Variable extends AbstractExpression {
	private String id;
	private Literal val;

	public Variable() {
		this(null);
	}
	public Variable(String id) {
		super(OperatorGroup.LITERAL);
		this.id = id;
	}

	public void setValue(Literal val) {
		this.val = val;
	}
	public Literal getValue() {
		return val;
	}

	public String getId() {
		return id;
	}
	public void setId(String id) {
		notifyChanged("id", this.id, this.id = id);
	}

	public void accept(IILVisitor visitor) {
		visitor.visitVariable(this);
	}
}