package unibo.cs.labss.editor.il.model.impl;

import unibo.cs.labss.editor.model.IEntity;
import unibo.cs.labss.editor.model.AbstractEntity;
import unibo.cs.labss.editor.model.IModel;
import unibo.cs.labss.editor.il.model.Expression;
import unibo.cs.labss.editor.il.model.IILVisitor;
import unibo.cs.labss.editor.il.model.Statement;

/**
 * @author Riccardo Solmi
 */
public class WhileStatement extends AbstractEntity implements Statement {
	private Expression exp;
	private Statement stm;

	public WhileStatement() {
	}
	public WhileStatement(Expression exp, Statement stm) {
		this.exp = exp;
		this.stm = stm;
	}

    public Object clone() {
    	WhileStatement ws = (WhileStatement)super.clone();
		ws.exp = (Expression)exp.clone();
		ws.stm = (Statement)stm.clone();
		return ws;
	}

    protected void setChildrenModel(IModel model) {
    	exp.setModel(model);
    	stm.setModel(model);
    }

	public Expression getExp() {
		return exp;
	}

	public Statement getStm() {
		return stm;
	}

	public void setExp(Expression exp) {
		notifyChanged(this.exp, this.exp = exp);
	}

	public void setStm(Statement stm) {
		notifyChanged(this.stm, this.stm = stm);
	}

	public void replaceChild(IEntity oldChild, IEntity newChild) {
		if (getExp() == oldChild)
			setExp((Expression)newChild);
		else if (getStm() == oldChild)
			setStm((Statement)newChild);
	}

	public void accept(IILVisitor visitor) {
		visitor.visitWhile(this);
	}
}