package unibo.cs.labss.editor.il.parts;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.IFigure;

import unibo.cs.labss.editor.il.figures.BinaryExpressionFigure;
import unibo.cs.labss.editor.il.model.Expression;
import unibo.cs.labss.editor.il.model.impl.AbstractBinaryExpression;
import unibo.cs.labss.editor.parts.AbstractPart;


public class BinaryExpressionPart extends AbstractPart {
	private final String opStr;
	
	public BinaryExpressionPart(String opStr) {
		this.opStr = opStr;
	}
	
	protected IFigure createFigure() {
		return new BinaryExpressionFigure(opStr);
	}
	
	protected AbstractBinaryExpression getBinaryExpression() {
		return (AbstractBinaryExpression)getModel();
	}	
	
	protected List getModelChildren() {
		refreshPrecedence();
		List list = new ArrayList(2);
		list.add(getBinaryExpression().getExp1());
		list.add(getBinaryExpression().getExp2());
		return list;
	}

	protected void refreshPrecedence() {
		AbstractBinaryExpression exp = getBinaryExpression();
		Expression exp1 = exp.getExp1();
		Expression exp2 = exp.getExp2();
		BinaryExpressionFigure fig = (BinaryExpressionFigure)getFigure();
		fig.showLeftParen(exp.hasPrecedence(exp1));
		fig.showRightParen(exp.hasPrecedence(exp2));
	}
}