package unibo.cs.labss.editor.il.parts;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.IFigure;

import unibo.cs.labss.editor.il.figures.IfElseStatementFigure;
import unibo.cs.labss.editor.il.model.Statement;
import unibo.cs.labss.editor.il.model.impl.BlockStatement;
import unibo.cs.labss.editor.il.model.impl.IfElseStatement;
import unibo.cs.labss.editor.parts.AbstractPart;

/**
 * @author Riccardo Solmi
 */
public class IfElseStatementPart extends AbstractPart {
    protected IFigure createFigure() {
        return new IfElseStatementFigure();
    }

    protected IfElseStatement getIfElseStatement() {
        return (IfElseStatement)getModel();
    }

    protected List getModelChildren() {
    	refreshBlockDelimiters();
    	List children = new ArrayList(3);
    	children.add(getIfElseStatement().getExp());
    	children.add(getIfElseStatement().getThenStm());
   		children.add(getIfElseStatement().getElseStm());
    	return children;
    }

    private void refreshBlockDelimiters() {
    	((IfElseStatementFigure)getFigure()).showThenBraces(isBlock(getIfElseStatement().getThenStm()));
    	((IfElseStatementFigure)getFigure()).showElseBraces(isBlock(getIfElseStatement().getElseStm()));
    }
    
    private boolean isBlock(Statement s) {
    	return s instanceof BlockStatement;// && ((BlockStatement)s).size()>1;
    		
    }
}
