package unibo.cs.labss.editor.il.parts;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.IFigure;

import unibo.cs.labss.editor.il.figures.IfStatementFigure;
import unibo.cs.labss.editor.il.model.Statement;
import unibo.cs.labss.editor.il.model.impl.BlockStatement;
import unibo.cs.labss.editor.il.model.impl.IfStatement;
import unibo.cs.labss.editor.parts.AbstractPart;

/**
 * @author Riccardo Solmi
 */
public class IfStatementPart extends AbstractPart {
    protected IFigure createFigure() {
        return new IfStatementFigure();
    }

    protected IfStatement getIfStatement() {
        return (IfStatement)getModel();
    }


    protected List getModelChildren() {
    	refreshBlockDelimiters();
    	List children = new ArrayList(3);
    	children.add(getIfStatement().getExp());
    	children.add(getIfStatement().getThenStm());
    	return children;
    }

    private void refreshBlockDelimiters() {
    	((IfStatementFigure)getFigure()).showThenBraces(isBlock(getIfStatement().getThenStm()));
    }
    
    private boolean isBlock(Statement s) {
    	return s instanceof BlockStatement;// && ((BlockStatement)s).size()>1;
    		
    }
}
