package unibo.cs.labss.editor.il.parts;

import java.beans.PropertyChangeEvent;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.tools.DirectEditManager;
import org.eclipse.jface.viewers.TextCellEditor;

import unibo.cs.labss.editor.figures.StyledLabel;
import unibo.cs.labss.editor.il.policies.LiteralDirectEditPolicy;
import unibo.cs.labss.editor.parts.AbstractPart;
import unibo.cs.labss.editor.parts.LabelCellEditorLocator;
import unibo.cs.labss.editor.parts.LabelDirectEditManager;

/**
 * @author Riccardo Solmi
 */
public class LiteralPart extends AbstractPart {
	protected DirectEditManager manager;
	
	protected IFigure createFigure() {
    	return StyledLabel.createLiteral();
    }

    protected void refreshVisuals() {
	    ((Label)getFigure()).setText(getModel().toString());
    }

    protected void propertyChangeUI(PropertyChangeEvent evt) {
    	if (evt.getPropertyName().equals("value"))
    		refreshVisuals();
    	else
    		super.propertyChangeUI(evt);
    }

    protected void createEditPolicies() {
    	super.createEditPolicies();
    	installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new LiteralDirectEditPolicy());
    }

    
    protected void performDirectEdit() {
    	if (manager == null) {
    		Label label = (Label) getFigure();
    		manager = new LabelDirectEditManager(this, TextCellEditor.class, new LabelCellEditorLocator(label), label);
    	}
    	manager.show();
    }
}
