package unibo.cs.labss.editor.il.parts;

import java.beans.PropertyChangeEvent;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.tools.DirectEditManager;
import org.eclipse.jface.viewers.TextCellEditor;

import unibo.cs.labss.editor.figures.SelectableStyledLabel;
import unibo.cs.labss.editor.figures.StyledLabel;
import unibo.cs.labss.editor.il.model.impl.Variable;
import unibo.cs.labss.editor.il.policies.VariableDirectEditPolicy;
import unibo.cs.labss.editor.parts.AbstractPart;
import unibo.cs.labss.editor.parts.LabelCellEditorLocator;
import unibo.cs.labss.editor.parts.LabelDirectEditManager;

/**
 * @author Riccardo Solmi
 */
public class VariablePart extends AbstractPart {
	protected DirectEditManager manager;

	protected IFigure createFigure() {
		return StyledLabel.createIdentifier();
	}

	protected void refreshVisuals() {
		((SelectableStyledLabel)getFigure()).setText(((Variable)getModel()).getId());
	}

	protected void propertyChangeUI(PropertyChangeEvent evt) {
		if (evt.getPropertyName().equals("id"))
			refreshVisuals();
		else
			super.propertyChangeUI(evt);
	}

	protected void createEditPolicies() {
		super.createEditPolicies();
		installEditPolicy(EditPolicy.DIRECT_EDIT_ROLE, new VariableDirectEditPolicy());
	}

	protected void performDirectEdit() {
		if (manager == null) {
			Label label = (Label) getFigure();
			manager = new LabelDirectEditManager(this, TextCellEditor.class, new LabelCellEditorLocator(label), label);
		}
		manager.show();
	}
}
