package unibo.cs.labss.editor.il.parts;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.IFigure;

import unibo.cs.labss.editor.il.figures.WhileStatementFigure;
import unibo.cs.labss.editor.il.model.impl.BlockStatement;
import unibo.cs.labss.editor.il.model.impl.WhileStatement;
import unibo.cs.labss.editor.parts.AbstractPart;

/**
 * @author Riccardo Solmi
 */
public class WhileStatementPart extends AbstractPart {
    protected IFigure createFigure() {
        return new WhileStatementFigure();
    }

    protected WhileStatement getWhileStatement() {
        return (WhileStatement)getModel();
    }
    
    protected List getModelChildren() {
    	refreshBlockDelimiters();
    	List children = new ArrayList(2);
    	children.add(getWhileStatement().getExp());
    	children.add(getWhileStatement().getStm());
    	return children;
    }

	private void refreshBlockDelimiters() {
		((WhileStatementFigure)getFigure()).showBraces(getWhileStatement().getStm() instanceof BlockStatement);
	}
}
