package unibo.cs.labss.editor.il.policies;

import org.eclipse.draw2d.Label;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.DirectEditPolicy;
import org.eclipse.gef.requests.DirectEditRequest;
import unibo.cs.labss.editor.il.model.impl.BooleanLiteral;
import unibo.cs.labss.editor.il.model.impl.IntegerLiteral;
import unibo.cs.labss.editor.il.commands.ChangeBooleanLiteralCommand;
import unibo.cs.labss.editor.il.commands.ChangeIntegerLiteralCommand;

public class LiteralDirectEditPolicy extends DirectEditPolicy {

	protected Command getDirectEditCommand(DirectEditRequest request) {
		if(getHost().getModel() instanceof BooleanLiteral) {
			ChangeBooleanLiteralCommand cmd = new ChangeBooleanLiteralCommand();
			cmd.setSource((BooleanLiteral) getHost().getModel());
			cmd.setOldValue(((BooleanLiteral) getHost().getModel()).isVal());

			// update with newly typed data
			String newValue = (String) request.getCellEditor().getValue();
			if(newValue.equals(Boolean.TRUE.toString()) || newValue.equals(Boolean.FALSE.toString()))
				cmd.setNewValue(Boolean.valueOf(newValue).booleanValue());
			else
				cmd = null;
			return cmd;
		} else {
			ChangeIntegerLiteralCommand cmd = new ChangeIntegerLiteralCommand();
			cmd.setSource((IntegerLiteral) getHost().getModel());
			cmd.setOldValue(((IntegerLiteral) getHost().getModel()).getVal());

			// update with newly typed data
			try {
				int newValue = Integer.parseInt((String) request.getCellEditor().getValue());
				cmd.setNewValue(newValue);
			} catch (NumberFormatException e) {
				cmd = null;
			}
			return cmd;
		}
	}

	protected void showCurrentEditValue(DirectEditRequest request) {
		String value = (String) request.getCellEditor().getValue();
		((Label) getHostFigure()).setText(value);
		//hack to prevent async layout from placing the cell editor twice.
		//getHostFigure().getUpdateManager().performUpdate();
	}
}
